<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::adsl::MessageInterpreter Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1adsl.html">adsl</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_message_interpreter.html">MessageInterpreter</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1adsl_1_1_message_interpreter-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::adsl::MessageInterpreter Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_message_interpreter_8h_source.html">MessageInterpreter.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::adsl::MessageInterpreter:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1adsl_1_1_message_interpreter__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1adsl_1_1_message_interpreter_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1adsl_1_1_message_interpreter_inherit__map" id="alexa_client_s_d_k_1_1adsl_1_1_message_interpreter_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::MessageObserver\lInterface" alt="" coords="5,5,230,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::adsl::MessageInterpreter:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1adsl_1_1_message_interpreter__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1adsl_1_1_message_interpreter_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1adsl_1_1_message_interpreter_coll__map" id="alexa_client_s_d_k_1_1adsl_1_1_message_interpreter_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::MessageObserver\lInterface" alt="" coords="5,5,230,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a9055117c7c822c0e7324939a3ea266c0"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_message_interpreter.html#a9055117c7c822c0e7324939a3ea266c0">MessageInterpreter</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface</a> &gt; exceptionEncounteredSender, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_sequencer_interface.html">avsCommon::sdkInterfaces::DirectiveSequencerInterface</a> &gt; directiveSequencer, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager_interface.html">avsCommon::avs::attachment::AttachmentManagerInterface</a> &gt; attachmentManager)</td></tr>
<tr class="separator:a9055117c7c822c0e7324939a3ea266c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbbfb9e269a1ff7dc157784cd33fcf23"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_message_interpreter.html#abbbfb9e269a1ff7dc157784cd33fcf23">receive</a> (const std::string &amp;contextId, const std::string &amp;message) override</td></tr>
<tr class="separator:abbbfb9e269a1ff7dc157784cd33fcf23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::MessageObserverInterface</a></td></tr>
<tr class="memitem:a92680a813e5e965d556020619fab3805 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface.html#a92680a813e5e965d556020619fab3805">~MessageObserverInterface</a> ()=default</td></tr>
<tr class="separator:a92680a813e5e965d556020619fab3805 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Class that converts <code>acl::Message</code> to <code>AVSDirective</code>, and passes those directives to a <code>DirectiveSequencerInterface</code>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a9055117c7c822c0e7324939a3ea266c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9055117c7c822c0e7324939a3ea266c0">&#9670;&nbsp;</a></span>MessageInterpreter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::adsl::MessageInterpreter::MessageInterpreter </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>exceptionEncounteredSender</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_sequencer_interface.html">avsCommon::sdkInterfaces::DirectiveSequencerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>directiveSequencer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager_interface.html">avsCommon::avs::attachment::AttachmentManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>attachmentManager</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionEncounteredSender</td><td>The exceptions encountered messages sender, which will allow us to send exception encountered back to AVS. </td></tr>
    <tr><td class="paramname">directiveSequencerInterface</td><td>The DirectiveSequencerInterface implementation, which will receive <code>AVSDirectives</code>. </td></tr>
    <tr><td class="paramname">attachmentManager</td><td>The <code>AttachmentManager</code> which created <code>AVSDirectives</code> will use to acquire Attachments. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="abbbfb9e269a1ff7dc157784cd33fcf23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abbbfb9e269a1ff7dc157784cd33fcf23">&#9670;&nbsp;</a></span>receive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::adsl::MessageInterpreter::receive </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>contextId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>message</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A function that a client must implement to receive Messages from AVS.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">contextId</td><td>The context for the message, which in this case reflects the logical HTTP/2 stream the message arrived on. </td></tr>
    <tr><td class="paramname">message</td><td>The AVS message that has been received. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_observer_interface.html#a32734a0bfe74e1038309eca98212ce4b">alexaClientSDK::avsCommon::sdkInterfaces::MessageObserverInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/ADSL/include/ADSL/<a class="el" href="_message_interpreter_8h_source.html">MessageInterpreter.h</a></li>
<li>/workplace/avs-device-sdk/ADSL/src/<a class="el" href="_message_interpreter_8cpp.html">MessageInterpreter.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
